import { QueryEngine } from "./engine/mod.js";
let defaultContext = undefined;
let defaultEngine = undefined;
export const setDefaultContext = (context) => {
    defaultContext = context;
};
export const resolveContext = (context) => {
    if (!context && !defaultContext) {
        throw new Error("No context found. Please create a default context or pass one to createLens function");
    }
    return context || defaultContext;
};
export const setDefaultEngine = (engine) => {
    defaultEngine = engine;
};
export const resolveEngine = (engine) => {
    if (!engine && !defaultEngine) {
        setDefaultEngine(new QueryEngine());
        // TODO: consider the consequences here, maybe log a warning?
        /*throw new Error(
          "No engine found. Please create a default engine or pass one to createLens function",
        );*/
    }
    return engine || defaultEngine;
};
