import { braces, SparqlBuilder } from "./sparql_shared_builders.js";
class SparqlUpdateBuilder extends SparqlBuilder {
    WHERE(strings, ...values) {
        return this.template(strings, values, "WHERE", braces);
    }
    USING_NAMED(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "USING NAMED");
    }
    USING(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "USING");
    }
    INSERT(strings, ...values) {
        return this.template(strings, values, "INSERT", braces);
    }
    INSERT_DATA(strings, ...values) {
        return this.template(strings, values, "INSERT DATA", braces);
    }
    DELETE(strings, ...values) {
        return this.template(strings, values, "DELETE", braces);
    }
    DELETE_DATA(strings, ...values) {
        return this.template(strings, values, "DELETE DATA", braces);
    }
    WITH(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "WITH");
    }
}
export const INSERT = Object.assign((strings, ...values) => new SparqlUpdateBuilder().INSERT(strings, ...values), {
    DATA: (strings, ...values) => new SparqlUpdateBuilder().INSERT_DATA(strings, ...values),
});
export const DELETE = Object.assign((strings, ...values) => new SparqlUpdateBuilder().DELETE(strings, ...values), {
    DATA: (strings, ...values) => new SparqlUpdateBuilder().DELETE_DATA(strings, ...values),
});
export const WITH = (stringOrNamedNode) => new SparqlUpdateBuilder().WITH(stringOrNamedNode);
