"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryEngineProxy = void 0;
const rdf_js_1 = require("../rdf.js");
const global_js_1 = require("../global.js");
class QueryEngineProxy {
    constructor(context, engine) {
        Object.defineProperty(this, "context", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "engine", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.context = (0, global_js_1.resolveContext)(context);
        this.engine = (0, global_js_1.resolveEngine)(engine);
    }
    queryBoolean(query) {
        return this.engine.queryBoolean(query, this.context);
    }
    async queryBindings(query) {
        const bindingsStream = await this.engine.queryBindings(query, this.context);
        return bindingsStream.toArray();
    }
    async queryGraph(query) {
        const quadStream = await this.engine.queryQuads(query, this.context);
        const quads = await (quadStream.toArray());
        return (0, rdf_js_1.quadsToGraph)(quads);
    }
    queryVoid(query) {
        return this.engine.queryVoid(query, this.context);
    }
}
exports.QueryEngineProxy = QueryEngineProxy;
