"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveEngine = exports.setDefaultEngine = exports.resolveContext = exports.setDefaultContext = void 0;
const mod_js_1 = require("./engine/mod.js");
let defaultContext = undefined;
let defaultEngine = undefined;
const setDefaultContext = (context) => {
    defaultContext = context;
};
exports.setDefaultContext = setDefaultContext;
const resolveContext = (context) => {
    if (!context && !defaultContext) {
        throw new Error("No context found. Please create a default context or pass one to createLens function");
    }
    return context || defaultContext;
};
exports.resolveContext = resolveContext;
const setDefaultEngine = (engine) => {
    defaultEngine = engine;
};
exports.setDefaultEngine = setDefaultEngine;
const resolveEngine = (engine) => {
    if (!engine && !defaultEngine) {
        (0, exports.setDefaultEngine)(new mod_js_1.QueryEngine());
        // TODO: consider the consequences here, maybe log a warning?
        /*throw new Error(
          "No engine found. Please create a default engine or pass one to createLens function",
        );*/
    }
    return engine || defaultEngine;
};
exports.resolveEngine = resolveEngine;
