"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DESCRIBE = exports.ASK = exports.CONSTRUCT = exports.SELECT = void 0;
const sparql_shared_builders_js_1 = require("./sparql_shared_builders.js");
class SparqlQueryBuilder extends sparql_shared_builders_js_1.SparqlBuilder {
    OFFSET(number) {
        return this.number(number, "OFFSET");
    }
    LIMIT(number) {
        return this.number(number, "LIMIT");
    }
    ORDER_BY(strings, ...values) {
        return this.template(strings, values, "ORDER BY");
    }
    HAVING(strings, ...values) {
        return this.template(strings, values, "HAVING", sparql_shared_builders_js_1.parentheses);
    }
    GROUP_BY(strings, ...values) {
        return this.template(strings, values, "GROUP BY");
    }
    WHERE(strings, ...values) {
        return this.template(strings, values, "WHERE", sparql_shared_builders_js_1.braces);
    }
    FROM_NAMED(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "FROM NAMED");
    }
    FROM(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "FROM");
    }
    SELECT(strings, ...values) {
        return this.template(strings, values, "SELECT");
    }
    SELECT_DISTINCT(strings, ...values) {
        return this.template(strings, values, "SELECT DISTINCT");
    }
    SELECT_REDUCED(strings, ...values) {
        return this.template(strings, values, "SELECT REDUCED");
    }
    CONSTRUCT(strings, ...values) {
        return this.template(strings, values, "CONSTRUCT", sparql_shared_builders_js_1.braces);
    }
    CONSTRUCT_WHERE(strings, ...values) {
        return this.template(strings, values, "CONSTRUCT WHERE", sparql_shared_builders_js_1.braces);
    }
    ASK(strings, ...values) {
        return this.template(strings, values, "ASK", sparql_shared_builders_js_1.braces);
    }
    ASK_FROM(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "ASK\nFROM");
    }
    ASK_FROM_NAMED(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "ASK\nFROM NAMED");
    }
    ASK_WHERE(strings, ...values) {
        return this.template(strings, values, "ASK\nWHERE", sparql_shared_builders_js_1.braces);
    }
    DESCRIBE(strings, ...values) {
        return this.template(strings, values, "DESCRIBE");
    }
}
exports.SELECT = Object.assign((strings, ...values) => new SparqlQueryBuilder().SELECT(strings, ...values), {
    DISTINCT: (strings, ...values) => new SparqlQueryBuilder().SELECT_DISTINCT(strings, ...values),
    REDUCED: (strings, ...values) => new SparqlQueryBuilder().SELECT_REDUCED(strings, ...values),
    get ALL() {
        return new SparqlQueryBuilder().SELECT `*`;
    },
});
exports.CONSTRUCT = Object.assign((strings, ...values) => new SparqlQueryBuilder().CONSTRUCT(strings, ...values), {
    WHERE: (strings, ...values) => new SparqlQueryBuilder().CONSTRUCT_WHERE(strings, ...values),
});
exports.ASK = Object.assign((strings, ...values) => new SparqlQueryBuilder().ASK(strings, ...values), {
    FROM: (stringOrNamedNode) => new SparqlQueryBuilder().ASK_FROM(stringOrNamedNode),
    FROM_NAMED: (stringOrNamedNode) => new SparqlQueryBuilder().ASK_FROM_NAMED(stringOrNamedNode),
    WHERE: (strings, ...values) => new SparqlQueryBuilder().ASK_WHERE(strings, ...values),
});
const DESCRIBE = (strings, ...values) => new SparqlQueryBuilder().DESCRIBE(strings, ...values);
exports.DESCRIBE = DESCRIBE;
