"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WITH = exports.DELETE = exports.INSERT = void 0;
const sparql_shared_builders_js_1 = require("./sparql_shared_builders.js");
class SparqlUpdateBuilder extends sparql_shared_builders_js_1.SparqlBuilder {
    WHERE(strings, ...values) {
        return this.template(strings, values, "WHERE", sparql_shared_builders_js_1.braces);
    }
    USING_NAMED(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "USING NAMED");
    }
    USING(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "USING");
    }
    INSERT(strings, ...values) {
        return this.template(strings, values, "INSERT", sparql_shared_builders_js_1.braces);
    }
    INSERT_DATA(strings, ...values) {
        return this.template(strings, values, "INSERT DATA", sparql_shared_builders_js_1.braces);
    }
    DELETE(strings, ...values) {
        return this.template(strings, values, "DELETE", sparql_shared_builders_js_1.braces);
    }
    DELETE_DATA(strings, ...values) {
        return this.template(strings, values, "DELETE DATA", sparql_shared_builders_js_1.braces);
    }
    WITH(stringOrNamedNode) {
        return this.namedNode(stringOrNamedNode, "WITH");
    }
}
exports.INSERT = Object.assign((strings, ...values) => new SparqlUpdateBuilder().INSERT(strings, ...values), {
    DATA: (strings, ...values) => new SparqlUpdateBuilder().INSERT_DATA(strings, ...values),
});
exports.DELETE = Object.assign((strings, ...values) => new SparqlUpdateBuilder().DELETE(strings, ...values), {
    DATA: (strings, ...values) => new SparqlUpdateBuilder().DELETE_DATA(strings, ...values),
});
const WITH = (stringOrNamedNode) => new SparqlUpdateBuilder().WITH(stringOrNamedNode);
exports.WITH = WITH;
