import { AsyncIterator } from "asynciterator";
export { ArrayIterator, type AsyncIterator, MappingIterator, } from "asynciterator";
type TreeNode<T> = {
    [property: string]: T[] | TreeNode<T>;
};
export type Tree<T> = T[] | TreeNode<T>;
type Subtree<T> = {
    type: "node";
    tree: TreeNode<T>;
    parent?: Subtree<T>;
    items: string[];
    path: string[];
    index: number;
} | {
    type: "leaf";
    parent?: Subtree<T>;
    items: T[];
    path: string[];
    index: number;
};
export declare class TreeIterator<T> extends AsyncIterator<[...string[], T]> {
    private _tree;
    private _pointer;
    constructor(tree: Tree<T>);
    read(): [...string[], T] | null;
    protected _buildPointerFromSource(tree: Tree<T>, path?: string[]): Subtree<T>;
    protected _findNextCommonSegment(): void;
    protected _findNextLeaf(): void;
}
