import { type Context, type IQueryEngine, type RDF } from "../rdf.js";
import { type ResolverType } from "./query_resolvers.js";
export declare class QueryEngine implements IQueryEngine {
    protected getSparqlEndpoint(context?: Context): string;
    protected getFetch(context?: Context): typeof fetch;
    query(query: string, responseType: string, context?: Context): Promise<Response>;
    queryAndResolve<T extends ResolverType>(type: T, query: string, context?: Context): Promise<{
        boolean: boolean;
        bindings: RDF.ResultStream<RDF.Bindings>;
        quads: RDF.ResultStream<RDF.Quad>;
    }[T]>;
    queryBindings(query: string, context?: Context): Promise<RDF.ResultStream<RDF.Bindings>>;
    queryBoolean(query: string, context?: Context): Promise<boolean>;
    queryQuads(query: string, context?: Context): Promise<RDF.ResultStream<RDF.Quad>>;
    queryVoid(query: string, context?: Context): Promise<void>;
}
