import { type RDF } from "../rdf.js";
type ResolveFormat = {
    "boolean": boolean;
    "bindings": RDF.ResultStream<RDF.Bindings>;
    "quads": RDF.ResultStream<RDF.Quad>;
};
export type ResolverType = keyof ResolveFormat;
export declare const getResponseTypes: (resolverType: ResolverType) => string[];
export declare const resolve: <T extends keyof ResolveFormat>(resolverType: T, response: Response) => Promise<ResolveFormat[T]>;
export {};
