import type { Schema } from "../schema/mod.js";
import { type Context, type Iri, type RDF } from "../rdf.js";
import type { Entity } from "./types.js";
export declare class QueryBuilder {
    private readonly schema;
    private readonly schemaProperties;
    private readonly context;
    private readonly df;
    constructor(schema: Schema, context: Context);
    private getResourceSignature;
    private getTypesSignature;
    private entitiesToQuads;
    private getShape;
    countQuery(): string;
    getQuery(where?: string | RDF.Quad[], limit?: number): string;
    getByIrisQuery(iris: Iri[]): string;
    insertQuery(entities: Entity[]): string;
    insertDataQuery(quads: RDF.Quad[]): string;
    deleteQuery: (iris: Iri[]) => string;
    deleteDataQuery(quads: RDF.Quad[]): string;
    updateQuery(entities: Entity[]): string;
}
