import type { Context, RDF } from "../rdf.js";
import type { Schema } from "../schema/mod.js";
import type { Entity } from "./types.js";
export declare class QueryHelper {
    private readonly entity;
    private readonly schema;
    private readonly context;
    private readonly variableInitCounter;
    private quads?;
    private variableQuads?;
    constructor(entity: Entity, schema: Schema, context: Context, variableInitCounter?: number);
    getQuads(): RDF.Quad[];
    getVariableQuads(): RDF.Quad[];
    getDeleteQuads(): RDF.Quad[];
    getInsertQuads(): RDF.Quad[];
    getWhereQuads(): RDF.Quad[];
    private getEntityWithReplacedVariables;
    private replaceVariables;
}
