type NamespacePrototype = {
    iri: string;
    prefix: string;
    terms: readonly string[];
};
type NamespacePrefix<Namespace extends NamespacePrototype> = Namespace["prefix"];
type NamespaceIri<Namespace extends NamespacePrototype> = Namespace["iri"];
type NamespaceObject<Namespace extends NamespacePrototype> = {
    [Term in Namespace["terms"][number]]: `${NamespacePrefix<Namespace>}${Term}`;
};
export declare const createNamespace: <N extends NamespacePrototype, I = NamespaceIri<N>, P = NamespacePrefix<N>, O = NamespaceObject<N>>(namespaceSpec: N) => O & {
    $prefix: P;
    $iri: I;
};
export {};
