import { DataFactory, RDF } from "../rdf.js";
import { type SparqlValue } from "./sparql_tag.js";
type Wrap = (keyword: string, value: string) => string;
export declare const braces: Wrap;
export declare const parentheses: Wrap;
export declare abstract class SparqlBuilder {
    protected value: string;
    protected dataFactory: DataFactory<RDF.Quad>;
    build(): string;
    private sparql;
    protected template(strings: TemplateStringsArray, values: SparqlValue[], keyword: string, wrap?: Wrap): this;
    protected namedNode(stringOrNamedNode: string | RDF.NamedNode<string>, keyword: string, wrap?: Wrap): this;
    protected number(number: number, keyword: string, wrap?: Wrap): this;
}
export {};
