import { SparqlBuilder } from "./sparql_shared_builders.js";
import { type RDF } from "../rdf.js";
import { type SparqlValue } from "./sparql_tag.js";
type Builders<T extends keyof SparqlUpdateBuilder> = Pick<SparqlUpdateBuilder, T>;
declare class SparqlUpdateBuilder extends SparqlBuilder {
    WHERE(strings: TemplateStringsArray, ...values: SparqlValue[]): Builders<"build">;
    USING_NAMED(stringOrNamedNode: string | RDF.NamedNode<string>): Builders<"USING_NAMED" | "WHERE">;
    USING(stringOrNamedNode: string | RDF.NamedNode<string>): Builders<"USING" | "USING_NAMED" | "WHERE">;
    INSERT(strings: TemplateStringsArray, ...values: SparqlValue[]): Builders<"USING" | "USING_NAMED" | "WHERE">;
    INSERT_DATA(strings: TemplateStringsArray, ...values: SparqlValue[]): Builders<"build">;
    DELETE(strings: TemplateStringsArray, ...values: SparqlValue[]): Builders<"INSERT" | "USING" | "USING_NAMED" | "WHERE">;
    DELETE_DATA(strings: TemplateStringsArray, ...values: SparqlValue[]): Builders<"build">;
    WITH(stringOrNamedNode: string | RDF.NamedNode<string>): Builders<"INSERT" | "DELETE">;
}
export declare const INSERT: ((strings: TemplateStringsArray, ...values: SparqlValue[]) => Builders<"WHERE" | "USING_NAMED" | "USING">) & {
    DATA: (strings: TemplateStringsArray, ...values: SparqlValue[]) => Builders<"build">;
};
export declare const DELETE: ((strings: TemplateStringsArray, ...values: SparqlValue[]) => Builders<"WHERE" | "USING_NAMED" | "USING" | "INSERT">) & {
    DATA: (strings: TemplateStringsArray, ...values: SparqlValue[]) => Builders<"build">;
};
export declare const WITH: (stringOrNamedNode: string | RDF.NamedNode<string>) => Builders<"INSERT" | "DELETE">;
export {};
